Bug 95402 - TEMPLATE MANAGER: Improve Save as Template workflow
Summary: TEMPLATE MANAGER: Improve Save as Template workflow
Status: RESOLVED FIXED
Alias: None
Product: LibreOffice
Classification: Unclassified
Component: UI (show other bugs)
Version:
(earliest affected)
4.0.0.3 release
Hardware: Other All
: medium enhancement
Assignee: Akshay Deep
URL:
Whiteboard:
Keywords:
Depends on:
Blocks: Templates
  Show dependency treegraph
 
Reported: 2015-10-28 21:35 UTC by Yousuf Philips (jay)
Modified: 2016-10-18 14:51 UTC (History)
9 users (show)

See Also:
Crash report or crash signature:


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Yousuf Philips (jay) 2015-10-28 21:35:41 UTC
alvarezp from the design irc channel stated that the workflow isnt good when saving a template in the template manager and has suggested that the File > Templates > Save as Template action be changed as follows.

1. Template Manager title bar text be changed to 'Save Template'

2. Save button be move from top toolbar to the bottom area next to 'Close' button.

3. Rename 'Close' button to 'Cancel'.

4. Hide 'Get more templates for LibreOffice button'.

5. Hide tab button as you cant save to another template category.

His mockup - http://snag.gy/vEXqI.jpg
Comment 1 Cor Nouws 2015-10-29 07:29:40 UTC
Nice - thanks both!
Comment 2 Octavio Alvarez 2015-10-31 23:06:58 UTC
Also, and the most important, add a "Save as new template" icon to the list of templates to choose from.
Comment 3 Yousuf Philips (jay) 2015-11-01 15:04:02 UTC
(In reply to Octavio Alvarez from comment #2)
> Also, and the most important, add a "Save as new template" icon to the list
> of templates to choose from.

Not sure why we would need that icon in the list, as the dialog is to set which folder it should be placed in. This is no different than the 'Save As' dialog, where you select the folder you want to place it in and set the name you want to use.

This enhancement goes well with my proposal to redesign the template manager - https://docs.google.com/document/d/1JRPNdeHQpgqiqJv8LW-RHOjtHN8EMX0qK98QBnr10Yg/edit?usp=sharing
Comment 4 Octavio Alvarez 2015-11-05 02:38:38 UTC
(In reply to Yousuf (Jay) Philips from comment #3)
> Not sure why we would need that icon in the list, as the dialog is to set
> which folder it should be placed in. This is no different than the 'Save As'
> dialog, where you select the folder you want to place it in and set the name
> you want to use.

The icon is *the most important change* among all that I suggested becuase, as I said on IRC: it currently sends a wrong visual message.

Bear me with this thought: It gave me a choice of templates and I had a 'Save' button. I don't want to save it to any of those. By having a choice of templates I expect to click on one of those and then clicking 'Save' to perform my will.

I can't predict what the 'Save' button does before clicking it (a priori). It currently turns out that clicking 'Save' actually asks for something. This is completely opposite to the currently existing, universal workflow of saving *anything*.

At least, when a new 'Save as new template' icon is introduced as one of the options, it will visually guide me to click on it because that's what I want to do and then think 'Ok, I selected something, now I must find a button to perform the save'.
Comment 5 Yousuf Philips (jay) 2015-11-05 23:02:32 UTC
(In reply to Octavio Alvarez from comment #4)
> The icon is *the most important change* among all that I suggested becuase,
> as I said on IRC: it currently sends a wrong visual message.

I'm assuming you mean it sends the wrong visual message without the icon.

> Bear me with this thought: It gave me a choice of templates and I had a
> 'Save' button. I don't want to save it to any of those. By having a choice
> of templates I expect to click on one of those and then clicking 'Save' to
> perform my will.

That is quite opposite to the universal workflow of saving anything. When you open the Save or Save As dialog, the primary thing is to select a folder if neede, which may have existing files in it, and then type a new file name.

> I can't predict what the 'Save' button does before clicking it (a priori).
> It currently turns out that clicking 'Save' actually asks for something.
> This is completely opposite to the currently existing, universal workflow of
> saving *anything*.

Yes as there isnt a filename field to type in the template name, a dialog appears after clicking the 'Save' button. This isnt that outside of the norm that it would confuse users.

> At least, when a new 'Save as new template' icon is introduced as one of the
> options, it will visually guide me to click on it because that's what I want
> to do and then think 'Ok, I selected something, now I must find a button to
> perform the save'.

I find this quite confusing that if i wanted to save something, i would have to preselect an item already in the list of file/template names and then click a Save button. Maybe the simplest thing is to do would be to change the 'Save' button to 'Save Template Here'.
Comment 6 steve -_- 2015-11-05 23:12:00 UTC
nice suggestions. I like most, but a clear no to having a "save as" icon. the rest is great!
Comment 7 Octavio Alvarez 2015-11-06 01:24:10 UTC
(In reply to Yousuf (Jay) Philips from comment #5)
> > The icon is *the most important change* among all that I suggested becuase,
> > as I said on IRC: it currently sends a wrong visual message.
> 
> I'm assuming you mean it sends the wrong visual message without the icon.

Yes. It sends the message of 'choose a template to save over'. It gives no visual cues whatsoever that saving as a new template is possible at all.

> > Bear me with this thought: It gave me a choice of templates and I had a
> > 'Save' button. I don't want to save it to any of those. By having a choice
> > of templates I expect to click on one of those and then clicking 'Save' to
> > perform my will.
> 
> That is quite opposite to the universal workflow of saving anything. When
> you open the Save or Save As dialog, the primary thing is to select a folder
> if neede, which may have existing files in it, and then type a new file name.

I'd like to be more precise: when opening a Save As dialog, the primary thing is to select a *target file*, not a location. Choosing a location is just a requirement.

The current screen only gives visual cues for choosing existing files, not a new one. It doesn't give visual cues of location.

> > I can't predict what the 'Save' button does before clicking it (a priori).
> > It currently turns out that clicking 'Save' actually asks for something.
> > This is completely opposite to the currently existing, universal workflow
> > of saving *anything*.
> 
> Yes as there isnt a filename field to type in the template name, a dialog
> appears after clicking the 'Save' button. This isnt that outside of the norm
> that it would confuse users.

I didn't get the last sentence, sorry.

But if I understand correctly, what you say is also correct. As an alternative to the 'Save as new template' icon, there could be --instead-- a text field for choosing a new name *before* clicking 'Save'.

> > At least, when a new 'Save as new template' icon is introduced as one of
> > the options, it will visually guide me to click on it because that's what I
> > want to do and then think 'Ok, I selected something, now I must find a
> > button to perform the save'.
> 
> I find this quite confusing that if i wanted to save something, i would have
> to preselect an item already in the list of file/template names and then
> click a Save button. Maybe the simplest thing is to do would be to change
> the 'Save' button to 'Save Template Here'.

The simplest thing is to use a simple 'Save As' dialog. That's it.

With the 'Save as new template' icon, yes, you would have to preselect an item already in the list (but there is now a cue to know what to do to save a new template).

Renaming the button to 'Save template here' is still confusing if there are no visual cues. When given a choice of already existing templates and a 'Save template here', I feel like I *must* choose one of the templates before clicking the button, which leads to overwriting. The window does not cue that is giving the choice of location; the icons are the most prominent.
Comment 8 Kumāra 2016-04-29 02:58:27 UTC
I fully agree on the need for a better workflow. Currently it confuses me. I couldn't get it to work, causing me to think there's a bug. See Bug 99546.

I'd say this is more than just an enhancement. It's somewhat a bug.
Comment 9 Samuel Mehrbrodt (CIB) 2016-05-13 13:23:24 UTC
While revamping the template manager this summer gsoc we will create a new save as dialog with a simple category list selection and a name input field.

So I'm closing this bug.
Comment 10 Kumāra 2016-05-14 03:12:34 UTC
(In reply to Samuel Mehrbrodt (CIB) from comment #9)
> While revamping the template manager this summer gsoc we will create a new
> save as dialog with a simple category list selection and a name input field.
> 
> So I'm closing this bug.

OK, but shouldn't it be marked FIXED then?
WORKSFORME suggests that the 'bug' is invalid.
Comment 11 Octavio Alvarez 2016-05-14 05:05:39 UTC
Furthermore, shouldn't the bug be kept open until it is actually fixed? At this moment, the bug status is a blatant lie. It would also be a lie with FIXED.
Comment 12 steve -_- 2016-05-14 06:44:56 UTC
I agree with this being the wrong bug status.

@Samuel if GSoC bugs are handled differently or if there's a meta bug for GSoC items, let's work for that. But closing bugs, saying they *might* be solved in the future I find that odd.

But maybe you can elaborate on the thought process? (As always I may be missing obvious things)
Comment 13 Samuel Mehrbrodt (CIB) 2016-05-14 12:38:10 UTC
(In reply to steve -_- from comment #12)
> I agree with this being the wrong bug status.
> 
> @Samuel if GSoC bugs are handled differently or if there's a meta bug for
> GSoC items, let's work for that. But closing bugs, saying they *might* be
> solved in the future I find that odd.
> 
> But maybe you can elaborate on the thought process? (As always I may be
> missing obvious things)

I don't care about the status, just wanted to say this this won't be "fixed" as described here but that we are going another route.
Comment 14 Cor Nouws 2016-05-14 13:47:56 UTC
(In reply to steve -_- from comment #12)

> @Samuel if GSoC bugs are handled differently or if there's a meta bug for
> GSoC items, let's work for that. But closing bugs, saying they *might* be
> solved in the future I find that odd.

Especially since part of the current gaps in template functionality find their origin in a GSoC project ;)

But let's see and expect the positive. I understand and respect of course what Samuel wants to say.
Comment 15 Yousuf Philips (jay) 2016-05-19 10:10:26 UTC
So Akshay will be working on this as part of GSoC and the workflow mentioned in the description wont be implemented and the new workflow will be to have a simple save as template dialog which will contain controls for:

1) repository [drop down menu] - lists local and remote repositories. if there are multiple local repos, then each one will have its own entry in the list
2) folder [list box] - lists the folders in the repository
3) new folder [button] - option to add a new folder
4) file name [textbox]
5) ok and cancel buttons
Comment 16 Heiko Tietze 2016-05-19 21:00:15 UTC
(In reply to Yousuf (Jay) Philips from comment #15)
> ...
> 3) new folder [button] - option to add a new folder
> 4) file name [textbox]
> 5) ok and cancel buttons

Sounds like reinventing the wheel. Our own file dialog has all controls, however it lacks on many common features (95082, 95084, 95085, 95086). In respect to templates the places need to provide access to the right folders, of course.
Comment 17 Cor Nouws 2016-05-19 21:35:40 UTC
(In reply to Heiko Tietze from comment #16)
> (In reply to Yousuf (Jay) Philips from comment #15)
> > ...
> > 3) new folder [button] - option to add a new folder
> > 4) file name [textbox]
> > 5) ok and cancel buttons
> 
> Sounds like reinventing the wheel. Our own file dialog has all controls,
> however it lacks on many common features (95082, 95084, 95085, 95086). In
> respect to templates the places need to provide access to the right folders,
> of course.

see also bug 61396
and somewhere is (was?) a discussion on indeed simple improvements in the current file dialog. E.g. Shift+Open to open a template for editing..
There must be some organized discussion/place where I can find an overview?
Comment 18 Akshay Deep 2016-06-01 23:39:56 UTC
New Save As dialog for templates
https://gerrit.libreoffice.org/#/c/24545/
Comment 19 Timur 2016-06-03 13:37:35 UTC
Please set the target, I guess it's 5.3. And check Bug 94131.